@Echo off
SETLOCAL EnableDelayedExpansion

For /L %%A In ( 1, 1, 1 ) Do (
	Echo.
)

Echo === !__Alisha_DevKit_ZPath_[Project]! Tree.cmd ===

For /L %%A In ( 1, 1, 3 ) Do (
	Echo.
)

Pause

If "!__Alisha_tree_output!"=="" ( Exit /B )

Set __Alisha_tree_output=%__Alisha_tree_output:"=%

Echo __Alisha_tree_output is set as "!__Alisha_tree_output!"

If "!__Alisha_tree_output!"=="" ( Exit /B )

If Exist "!__Alisha_tree_output!" (
	Del /F "!__Alisha_tree_output!"
)

Type NUL >> "!__Alisha_tree_output!"

Set __Alisha_tree_ZPath=%__Alisha_tree_ZPath:"=%

Echo capture most recent HTML generator
Echo __Alisha_tree_ZPath is "%__Alisha_tree_ZPath%"

Rem Rem :: Pause

	Set /A "__Alisha_Draft_Previous=-1"
	Set /A "__Alisha_Draft_Current=!__Alisha_Draft_Previous!"
	
	For /F "delims=" %%G In ( 'Dir "%__Alisha_tree_ZPath%*.cmd" /B' ) Do (
		
		Echo Tree Draft: "%%G"
		
		Call :__Zoey_RemoveLeadingZeros %%G
		Set /A "__Alisha_Draft_Current=!__Alisha_Haystack!"
		
		If !__Alisha_Draft_Current! GTR !__Alisha_Draft_Previous! (
		
			Set /A "__Alisha_Draft_Previous=!__Alisha_Draft_Current!"
			Set "__Alisha_tree_script=%%G"
		
		)
	)
	
	Echo __Alisha_tree_script: "%__Alisha_tree_script%"
	Rem Rem :: Pause
	
	Echo preserve leading zeros
	Rem Rem :: Pause
	
	Set "__Alisha_draft=1!__Alisha_tree_script!"
	Set /A "__Alisha_draft=!__Alisha_draft!"
	Set "__Alisha_draft=%__Alisha_draft:~1%"
	
	Set "__Alisha_draftno=Draft No.!__Alisha_Draft_Current!"
	
Echo clone node to version
	Set "__Alisha_projectversion=!__Alisha_version_pretty!"
Rem Rem :: Pause

Call :__Zoey_Authors_Entry

Rem Echo Tree ".\" > "!__Alisha_tree_input!" /A /F
Rem Rem :: Pause

If Exist "!__Alisha_tree_output!" ( Del /F "!__Alisha_tree_output!" )

For /F "usebackq delims=" %%A In ( "!__Alisha_Environ_DevKit_Quick!html\tree-meta.html" ) Do ( 
	Echo %%A >> "!__Alisha_tree_output!"
)

Echo ^<title^>!__Alisha_Project_ZPath_[Project]! DevKit Log ( %__Alisha_ts% )^</title^> >> "!__Alisha_tree_output!"

For /F "usebackq delims=" %%A In ( "!__Alisha_Environ_DevKit_Quick!css\style.css" ) Do ( 
	Echo %%A >> "!__Alisha_tree_output!"
)

For /F "usebackq delims=" %%A In ( "!__Alisha_Environ_DevKit_Quick!html\fav.html" ) Do ( 
	Echo %%A >> "!__Alisha_tree_output!"
)

(
	Echo ^</head^>
	Echo ^<body^>
	Echo ^<table^>
	echo ^<tr^>^<td colspan="1" class="logo"^>
) >> "!__Alisha_tree_output!"

	for /F "usebackq delims=" %%A in ( "!__Alisha_Environ_DevKit_Quick!html\logo.html" ) do ( 
		echo %%A >> "!__Alisha_tree_output!"
	)
(
	Echo ^<td class="heading"^>
	Echo ^<h3^>!__Alisha_Project_ZPath_[Project]! System Tree^<br^>!__Alisha_ts!^</h3^>
	Echo ^<h3^>!__Alisha_Project_ZPath_[Version_Pretty] DevKit: !__Alisha_draftno!^<br^>By: !__Alisha_authors!^</h3^>
	Echo ^</td^>^</td^>^</tr^>
	Echo ^<tr^>^<td colspan="2"^>
) >> "!__Alisha_tree_output!"

Echo Tree Generator: "!__Alisha_tree_ZPath!!__Alisha_tree_script!"
Rem Rem :: Pause

If Exist "!__Alisha_tree_ZPath!!__Alisha_tree_script!" (
	Call "!__Alisha_tree_ZPath!!__Alisha_tree_script!"
)

(
	Echo ^</tr^>
	Echo ^</body^>^</html^>
) >>!__Alisha_tree_output!

Exit /B

:__Zoey_RemoveLeadingZeros

	Set "__Alisha_Haystack=%~1"
	Goto :__Zoey_RemoveLeadingZeros_Loop

:__Zoey_RemoveLeadingZeros_Loop

	If !__Alisha_Haystack! EQU 0 (
		Exit /B
	) Else If "!__Alisha_Haystack!"=="" (
		Set /A "__Alisha_Haystack=0"
		Exit /B
	) Else If "%__Alisha_Haystack:~0,1%"=="0" (
		Set "__Alisha_Haystack=%__Alisha_Haystack:~1%"
		Goto :__Zoey_RemoveLeadingZeros_Loop
	) Else (
		Set /A "__Alisha_Haystack=!__Alisha_Haystack!"
		Exit /B
	)

:__Zoey_Authors_Entry

Rem clone filename
	Set "__Alisha_authors=!__Alisha_tree_script!"
Rem remove suffix
	Set "__Alisha_authors=!__Alisha_authors:.cmd=!"
Rem remove hyphens
	Set "__Alisha_authors=!__Alisha_authors:-=!"
Rem remove draft
	Set "__Alisha_authors=!__Alisha_authors:%__Alisha_draft%=!"
Rem remove double spaces
	For /F "tokens=*" %%i In ( 'Echo !__Alisha_authors!' ) Do Set "__Alisha_authors=%%i"

Rem replace spaces with commas
	Set /A "__Alisha_author_count_1=0"
	For /F "tokens=* delims=" %%A In ( 'Echo !__Alisha_authors!' ) Do (	
		For %%B In (%%A) Do (
			Set /A "__Alisha_author_count_1+=1"
		)
	)

	Set "__Alisha_author_line="		
	Set /A "__Alisha_author_count_2=0"
	For /F "tokens=* delims=" %%A In ( 'Echo !__Alisha_authors!' ) Do (	
		For %%B In (%%A) Do (
			
			Set /A "__Alisha_author_count_2+=1"
			Set /A "__Alisha_author_count_3=!__Alisha_author_count_2!+1"
			
			Set "__Alisha_author_line=!__Alisha_author_line!%%B"

			If !__Alisha_author_count_3! LSS !author_count_1! Do (
				Set "__Alisha_author_line=!__Alisha_author_line!, "
			)
		)
	)
	
	Set "__Alisha_author_line=!__Alisha_author_line!,"
	Set "__Alisha_author_line=!__Alisha_author_line:, ,=!"
	
Rem replace underscores with spaces
	Set "__Alisha_author_line=!__Alisha_author_line:_= !"
	
Rem finalize authors string
	Set "__Alisha_authors=!__Alisha_author_line!"

	Exit /B
